(function (lmd, undefined) {
  'use strict';

  var cook = function (i) {
    return (document.cookie.match('(^|; )' + i + '=([^;]*)') || 0)[2];
  },
  redirect = function (url) {
    if (window.location + '' !== url) {
      window.location = url;
    }
  },
  getUrlWithHost = function (host) {
    return 'http://' + host + window.location.pathname + document.location.search + window.location.hash;
  },
  getConnectionUrl = function (host) {
    host = host.replace('www', 'wwws').replace('abonnes', 'wwws').replace('mobile', 'wwws')
        .replace('mobileabo', 'wwws');
    var url = 'https://' + host + '/account/?route=connexion&redirect=';
    return url + encodeURIComponent(window.location.href);
  },
  confOverload = function (cookieSuffix, conf) {
    var cookieConf = cook('over_conf_' + cookieSuffix),
        vars,
        key;

    if (! cookieConf) {
      return;
    }

    vars = JSON.parse(decodeURIComponent(cookieConf));

    for (key in vars) {
      if (conf[key] === undefined) {
        continue;
      }

      if (vars[key] === 'false') {
        conf[key] = false;
      } else if (vars[key] === 'true') {
        conf[key] = true;
      } else {
        conf[key] = vars[key];
      }
    }
  },
  cookieAlm = cook('alm'),
  cookieAbo = cook('tdb_user_abo'),
  aboUserId = 0,
  aboUserIdTab,
  currentUrl = window.location.href,
  context = lmd.context,
  conf = lmd.conf,
  freeApp = (context.application === 'mobileabo' ? 'mobile' : 'www'),
  abonneApp = (context.application === 'mobile' ? 'mobileabo' : 'abonnes'),
  tunnel = (context.pageType === 'Tunnel_Abonnement');

  if (cookieAlm !== undefined && cookieAlm !== '') {
    aboUserIdTab = cookieAlm.split('-');
    if (aboUserIdTab.length > 2) {
      aboUserId = parseInt(aboUserIdTab[aboUserIdTab.length - 2], 10);
    }
  }

  lmd.auth_sync = {};
  lmd.auth_sync.user_id = aboUserId;
  lmd.auth_sync.abonne = false;

  confOverload('fsw', conf.fsw, true);
  confOverload('advert', context.page.advert, false);

  var url = null;

  if (cookieAbo === undefined || cookieAbo === '') {
    if (context.application === 'abonnes' || context.application === 'mobileabo') {
      if (window.location.pathname.indexOf('/article/') > 1) {
        url = getUrlWithHost(conf[freeApp].location.hostname);
        redirect(url);
        return;
      }

      url = getConnectionUrl(conf[freeApp].location.hostname);
      redirect(url);
    }

    return;
  }

  lmd.auth_sync.abonne = true;

  if (!tunnel && context.application !== 'abonnes' && context.application !== 'mobileabo' &&
      !/\/teaser\/?/.test(currentUrl))
  {
    url = getUrlWithHost(conf[abonneApp].location.hostname);
    redirect(url);
    return;
  }

  if (!aboUserId && (context.application === 'abonnes' || context.application === 'mobileabo'))
  {
    url = 'http://' + conf[freeApp].location.hostname + '/teaser/?connexion&url_zop=' +
        encodeURIComponent(window.location.href);
    redirect(url);
    return;
  }
})(this.lmd);
